attribute vec4 aPos;
attribute vec3 aNor;

uniform mat4 P;
uniform mat4 MV;
uniform mat4 rTheta;
uniform float inner;
uniform mat4 viewMatrix;

varying vec3 normal;
varying vec3 vCol;
varying vec3 viewVec;

void main()
{
	gl_Position = P  * viewMatrix * MV * aPos;
	normal = vec3(rTheta * vec4(aNor.x, aNor.y, aNor.z, 0.0));

	if (inner == 1.0)
	{
		vCol = vec3(1.0, 0.0, 0.0);
	}
	else
	{
		//vCol = 0.5*(aNor + 1.0);
		vCol = vec3(1.0, 1.0, 1.0);
	}
}
